﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using System.IO;
using System.Diagnostics;

namespace FM4500 {
    public partial class FProperty : Form {

        private String _filename;
        private bool _modify = false;
        private bool isFolder = false;

            Label lFiletyp1;
            Label lFiletyp2;
            Label lOpenWith1;
            Label lOpenWith2;
            Label lFolder1;
            Label lFolder2;
            Label lSize1;
            Label lSize2;
            Label lSizeCluster1;
            Label lSizeCluster2;
            Label lCreateTime1;
            Label lCreateTime2;
            Label lChangeTime1;
            Label lChangeTime2;
            Label lLastAccess1;
            Label lLastAccess2;
            Label lAttribs1a;
            CheckBox chkReadonly;
            CheckBox chkHidden;
            CheckBox chkArchiv;
            CheckBox chkSystem;
            CheckBox chkCompressed;
            CheckBox chkEncrypted;
            Button bnGetFolderFileSize;


        public FProperty(Form parent, String filename) {
            InitializeComponent();
            this.Owner = parent;  // Important, because CenterOwner       
            this.StartPosition = FormStartPosition.CenterParent;
            _filename = filename;
        }

        private void FProperty_Load(object sender, EventArgs e) {
            Text = "Eigenschaften von " + Basis.getFilename(_filename);
            title2.Text = Text;
            setGUI1();
            setGUI2();
            setGUI3();
            bnUebernehmen.Enabled = false;
        }

        private void setGUI1() {
            bnUebernehmen.Enabled = false;
            tableLayoutPanel1.Dock = DockStyle.Fill;
            tabControl1.Dock = DockStyle.Fill;
            TableLayoutPanel tableLayoutPanel2 = new TableLayoutPanel();
            tableLayoutPanel2.ColumnCount = 3;
            tableLayoutPanel2.RowCount = 15;
            tableLayoutPanel2.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle());
            tableLayoutPanel2.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Percent, 50F));
            tableLayoutPanel2.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Percent, 50F));

            tableLayoutPanel2.Dock = DockStyle.Fill;
            TabPage tabitem = (TabPage)tabControl1.Controls[0];
            tabitem.Controls.Add(tableLayoutPanel2);

            lFiletyp1 = new Label();
            lFiletyp1.Text = "Dateityp";
            lFiletyp1.Name = "lFiletyp1";
            tableLayoutPanel2.Controls.Add(lFiletyp1, 0, 0);

            lFiletyp2 = new Label();
            lFiletyp2.Text = "Dateityp";
            lFiletyp2.Name = "lFiletyp2";
            tableLayoutPanel2.Controls.Add(lFiletyp2, 1, 0);
            // -----------

            lOpenWith1 = new Label();
            lOpenWith1.Text = "Öffnen mit";
            lOpenWith1.Name = "lOpenWith1";
            tableLayoutPanel2.Controls.Add(lOpenWith1, 0, 1);

            lOpenWith2 = new Label();
            lOpenWith2.Text = "lOpenWith2";
            lOpenWith2.Name = "lOpenWith2";
            tableLayoutPanel2.Controls.Add(lOpenWith2, 1, 1);

            // -----------
            // Rectangle

            lFolder1 = new Label();
            lFolder1.Text = "Verzeichnis";
            lFolder1.Name = "lFolder1";
            tableLayoutPanel2.Controls.Add(lFolder1, 0, 3);

            lFolder2 = new Label();
            lFolder2.Text = "lFolder2";
            lFolder2.Name = "lFolder2";
            tableLayoutPanel2.Controls.Add(lFolder2, 1, 3);
            // -----------

            lSize1 = new Label();
            lSize1.Text = "reale Größe";
            lSize1.Name = "lSize1";
            lSize1.AutoSize = true;
            tableLayoutPanel2.Controls.Add(lSize1, 0, 4);
            lSize2 = new Label();
            lSize2.Text = "lSize2";
            lSize2.Name = "lSize2";
            lSize2.AutoSize = true;
            tableLayoutPanel2.Controls.Add(lSize2, 1, 4);

            bnGetFolderFileSize = new Button();
            bnGetFolderFileSize.Text = "Bestimmen der Dateien";
            bnGetFolderFileSize.Name = "bnGetFolderFileSize";
            bnGetFolderFileSize.Dock = DockStyle.Fill;
            tableLayoutPanel2.Controls.Add(bnGetFolderFileSize, 2, 4);
            bnGetFolderFileSize.Click += new System.EventHandler(this.bnGetFolderFileSize_Click);
                //    <Button Grid.Column="2" Grid.Row="4" Name="bnGetFolderFileSize" Content="Bestimmen der Dateien" Click="bnGetFolderFileSize_Click" />
            // -----------


            lSizeCluster1 = new Label();
            lSizeCluster1.Text = "Größe mit BS-Cluster";
            lSizeCluster1.Name = "lSizeCluster1";
            lSizeCluster1.AutoSize = true;
            tableLayoutPanel2.Controls.Add(lSizeCluster1, 0, 5);
            lSizeCluster2 = new Label();
            lSizeCluster2.Text = "lSizeCluster2";
            lSizeCluster2.Name = "lSizeCluster2";
            lSizeCluster2.AutoSize = true;
            tableLayoutPanel2.Controls.Add(lSizeCluster2, 1, 5);
                    // <Rectangle Grid.Column="0" Grid.Row="6" Grid.ColumnSpan="3" Stretch="Fill" Fill="Gray" Height="1" />
            // -----------

            lCreateTime1 = new Label();
            lCreateTime1.Text = "Erstellt";
            lCreateTime1.Name = "lCreateTime1";
            tableLayoutPanel2.Controls.Add(lCreateTime1, 0, 7);
            lCreateTime2 = new Label();
            lCreateTime2.Text = "lCreateTime2";
            lCreateTime2.Name = "lCreateTime2";
            tableLayoutPanel2.Controls.Add(lCreateTime2, 1, 7);
            // -----------

            lChangeTime1 = new Label();
            lChangeTime1.Text = "Geändert";
            lChangeTime1.Name = "lChangeTime1";
            tableLayoutPanel2.Controls.Add(lChangeTime1, 0, 8);
            lChangeTime2 = new Label();
            lChangeTime2.Text = "lChangeTime2";
            lChangeTime2.Name = "lChangeTime2";
            tableLayoutPanel2.Controls.Add(lChangeTime2, 1, 8);
            // -----------

            lLastAccess1 = new Label();
            lLastAccess1.Text = "letzter Zugriff";
            lLastAccess1.Name = "lLastAccess1";
            tableLayoutPanel2.Controls.Add(lLastAccess1, 0, 9);
            lLastAccess2 = new Label();
            lLastAccess2.Text = "lLastAccess2";
            lLastAccess2.Name = "lLastAccess2";
            tableLayoutPanel2.Controls.Add(lLastAccess2, 1, 9);
              //      <Rectangle Grid.Column="0" Grid.Row="10" Grid.ColumnSpan="3" Stretch="Fill" Fill="Gray" Height="1" Margin="0 0 0 5"/>
            // -----------


            lAttribs1a = new Label();
            lAttribs1a.Text = "Attribute";
            lAttribs1a.Name = "lAttribs1a";
            tableLayoutPanel2.Controls.Add(lAttribs1a, 0, 11);

            chkReadonly = new CheckBox();
            chkReadonly.Text = "Schreibgeschützt";
            chkReadonly.Name = "chkReadonly";
            chkReadonly.Dock = DockStyle.Fill;
            tableLayoutPanel2.Controls.Add(chkReadonly, 1, 11);
            chkReadonly.CheckedChanged += new System.EventHandler(this.chBox_CheckedChanged);

            chkHidden = new CheckBox();
            chkHidden.Text = "Versteckt";
            chkHidden.Name = "chkHidden";
            chkHidden.Dock = DockStyle.Fill;
            tableLayoutPanel2.Controls.Add(chkHidden, 2, 11);
            chkReadonly.CheckedChanged += new System.EventHandler(this.chBox_CheckedChanged);

            chkArchiv = new CheckBox();
            chkArchiv.Text = "Archiv";
            chkArchiv.Name = "chkArchiv";
            chkArchiv.Dock = DockStyle.Fill;
            tableLayoutPanel2.Controls.Add(chkArchiv, 1, 12);
            chkReadonly.CheckedChanged += new System.EventHandler(this.chBox_CheckedChanged);

            chkSystem = new CheckBox();
            chkSystem.Text = "System";
            chkSystem.Name = "chkSystem";
            chkSystem.Dock = DockStyle.Fill;
            tableLayoutPanel2.Controls.Add(chkSystem, 2, 12);
            chkArchiv.CheckedChanged += new System.EventHandler(this.chBox_CheckedChanged);

            chkCompressed = new CheckBox();
            chkCompressed.Text = "Komprimiert";
            chkCompressed.Name = "chkCompressed";
            chkCompressed.Dock = DockStyle.Fill;
            chkCompressed.Enabled = false;
            tableLayoutPanel2.Controls.Add(chkCompressed, 1, 13);

            chkEncrypted = new CheckBox();
            chkEncrypted.Text = "Verschlüsselt";
            chkEncrypted.Name = "chkEncrypted";
            chkEncrypted.Dock = DockStyle.Fill;
            chkEncrypted.Enabled = false;
            tableLayoutPanel2.Controls.Add(chkEncrypted, 2, 13);

        }
        private void setGUI2() {
            FileInfo fileItem = new FileInfo(_filename);
            FileAttributes attribs = fileItem.Attributes;
            DriveInfo drv = new DriveInfo(_filename.Substring(0, 3));
            long clustersize = Basis.GetCluster(_filename.Substring(0, 3));
            if ((attribs & FileAttributes.Directory) == FileAttributes.Directory) {
                lFiletyp2.Text = "Verzeichnis";
                lOpenWith2.Text = "-";
                lFolder2.Text = "-";
                lSize2.Text = "-";
                lSizeCluster2.Text = "-";
                bnGetFolderFileSize.Visible = true;
                isFolder = true;
            }
            else {
                lFiletyp2.Text = "Datei";
                lOpenWith2.Text = "";
                lFolder2.Text = Basis.getPath(_filename);
                lSize2.Text = Basis.Best_KB(fileItem.Length) + "  (" + fileItem.Length + ") Bytes";
                long size = fileItem.Length / clustersize;
                if (fileItem.Length % clustersize > 0) size++;
                size *= clustersize;
                lSizeCluster2.Text = Basis.Best_KB(size) + "  (" + size + ") Bytes";
                bnGetFolderFileSize.Visible = false;
            }
            lCreateTime2.Text = fileItem.CreationTime.ToString();
            lChangeTime2.Text = fileItem.LastWriteTime.ToString();
            lLastAccess2.Text = fileItem.LastAccessTime.ToString();

            chkReadonly.Checked = fileItem.IsReadOnly;
            chkHidden.Checked = (attribs & FileAttributes.Hidden) == FileAttributes.Hidden;
            chkArchiv.Checked = (attribs & FileAttributes.Archive) == FileAttributes.Archive;
            chkSystem.Checked = (attribs & FileAttributes.System) == FileAttributes.System;
            chkCompressed.Checked = (attribs & FileAttributes.Compressed) == FileAttributes.Compressed;
            chkEncrypted.Checked = (attribs & FileAttributes.Encrypted) == FileAttributes.Encrypted;
          
        }
        private void setGUI3() {
            fileListe.Dock = DockStyle.Fill;
            fileListe.GridLines = true;		// Gitterlinien
            fileListe.View = View.Details;

            fileListe.Sorting = SortOrder.None;	// Sortiere (Alphanumerisch oder separat)
            // Spalten
            fileListe.Columns.Add("Eigenschaft", 140, HorizontalAlignment.Left);
            fileListe.Columns.Add("Wert", 260, HorizontalAlignment.Left);

            if (isFolder) return;


            ListViewItem item;
            FileVersionInfo fvi = FileVersionInfo.GetVersionInfo(_filename);
            item = new ListViewItem("Firma");
            item.SubItems.Add(fvi.CompanyName);
            fileListe.Items.Add(item);

            item = new ListViewItem("Copyright");
            item.SubItems.Add(fvi.LegalCopyright);
            fileListe.Items.Add(item);

            item = new ListViewItem("Trademarks");
            item.SubItems.Add(fvi.LegalTrademarks);
            fileListe.Items.Add(item);


            item = new ListViewItem("Build-Nr");
            item.SubItems.Add(fvi.FileMajorPart.ToString() + "." + fvi.FileMinorPart.ToString());
            fileListe.Items.Add(item);

            item = new ListViewItem("Einzelteilnr");
            item.SubItems.Add(fvi.FilePrivatePart.ToString());
            fileListe.Items.Add(item);

            
            item = new ListViewItem("Version");
            item.SubItems.Add(fvi.FileVersion);
            fileListe.Items.Add(item);

            item = new ListViewItem("Interner Name");
            item.SubItems.Add(fvi.InternalName);
            fileListe.Items.Add(item);

            item = new ListViewItem("Original-Dateiname");
            item.SubItems.Add(fvi.OriginalFilename);
            fileListe.Items.Add(item);


            item = new ListViewItem("Product-Build");
            item.SubItems.Add(fvi.ProductBuildPart.ToString());
            fileListe.Items.Add(item);

            item = new ListViewItem("Product-Name");
            item.SubItems.Add(fvi.ProductName);
            fileListe.Items.Add(item);

            item = new ListViewItem("Produkt-Version");
            item.SubItems.Add(fvi.ProductVersion);
            fileListe.Items.Add(item);

            item = new ListViewItem("Sprache");
            item.SubItems.Add(fvi.Language);
            fileListe.Items.Add(item);


            //fileListe.Items.Add(new VersionInfo("Private-Build", fvi.PrivateBuild));
            //fileListe.Items.Add(new VersionInfo("Special-Build", fvi.SpecialBuild));

            item = new ListViewItem("Kommentar");
            item.SubItems.Add(fvi.Comments);
            fileListe.Items.Add(item);

            item = new ListViewItem("Dateibeschreibung");
            item.SubItems.Add(fvi.FileDescription);
            fileListe.Items.Add(item);
        }// setGUI3


        private void Save() {
            _modify = false;
            bnUebernehmen.Enabled = false;
            FileInfo fileItem = new FileInfo(_filename);
            FileAttributes attribs = fileItem.Attributes;
            if (chkReadonly.Checked)
                attribs = attribs | FileAttributes.ReadOnly;
            else
                attribs = attribs & (~FileAttributes.ReadOnly);


            if (chkHidden.Checked)
                attribs = attribs | FileAttributes.Hidden;
            else
                attribs = attribs & (~FileAttributes.Hidden);


            if (chkArchiv.Checked)
                attribs = attribs | FileAttributes.Archive;
            else
                attribs = attribs & (~FileAttributes.Archive);


            if (chkSystem.Checked)
                attribs = attribs | FileAttributes.System;
            else
                attribs = attribs & (~FileAttributes.System);

            fileItem.Attributes = attribs;
        }


        class VersionInfo {
            String _property;
            String _value;
            public VersionInfo(String property, String value) {
                Property = property;
                if (value != null)
                    Value = value;
                else
                    Value = "-";
            }
            public VersionInfo(String property, int value) {
                Property = property;
                Value = value.ToString();
            }


            public String Property {
                get { return _property; }
                set { _property = value; }
            }
            public String Value {
                get { return _value; }
                set { _value = value; }
            }

        }

        
        private void chBox_CheckedChanged(object sender, EventArgs e) {
            _modify = true;
            bnUebernehmen.Enabled = true;
        }


        private void bnGetFolderFileSize_Click(object sender, EventArgs e) {
            bnGetFolderFileSize.Visible = false;
            long filecount;
            long filesize;
            long clusterfilesize;
            createFilesRekursiv(_filename, out filecount, out filesize, out clusterfilesize);
            lSize1.Text = "Anzahl der Dateien";
            lSize2.Text = filecount.ToString();
            lSizeCluster1.Text = "Summe in Bytes";
            lSizeCluster2.Text = Basis.Best_KB(filesize) + "  (mit Clustergröße:" + Basis.Best_KB(clusterfilesize) + ")";
        }

        private void createFilesRekursiv(String dirFilename, out long filecount, out long filesize, out long clusterfilesize) {
            String[] files = Directory.GetFiles(dirFilename, "*.*", SearchOption.AllDirectories);
            filecount = files.Length;
            filesize = 0;
            clusterfilesize = 0;
            long size;
            long clustersize = Basis.GetCluster(dirFilename.Substring(0, 3));
            foreach (String filename in files) {
                FileInfo fi = new FileInfo(filename);
                filesize += fi.Length;
                size = fi.Length / clustersize;
                if (fi.Length % clustersize > 0) size++;
                clusterfilesize += size * clustersize;
            }
        }


        private void bnOk_Click(object sender, EventArgs e) {
            Save();
            Close();
        }

        private void bnEsc_Click(object sender, EventArgs e) {
            Close();
        }

        private void bnUebernehmen_Click(object sender, EventArgs e) {
            Save();
        }
    }
}
