﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace FM4500 {
    public partial class FRenameWindow : Form {

        private String von;
        private bool retcode = false;

        public bool Retcode {
            get { return retcode; }
        }

        public String TBis {
            get { return tBis.Text.Trim(); }
        }

        public FRenameWindow(Form parent, String von, bool dir) {
            InitializeComponent();
            this.von = von;
            if (dir)
                labelTitel.Text = "Umbenennen eines Direktories";
            else
                labelTitel.Text = "Umbenennen einer Datei";
            this.Owner = parent;  // Important, because CenterOwner      
            this.StartPosition = FormStartPosition.CenterParent; 
            this.KeyPreview = true;
        }

        private void FRenameWindow_Load(object sender, EventArgs e) {

        }

        private void bnOk_Click(object sender, EventArgs e) {
            String newFile = tBis.Text.Trim();
            if (Basis.CheckDateinamen(newFile)) {
                if (newFile.Equals(tVon.Text.Trim())) {
                    Basis.ErrorMsg("Der neue Name muss sich von Original unterscheiden", "Hinweis");
                }
                else {
                    retcode = true;
                    Close();
                }
            }
            else {
                Basis.ErrorMsg("Der neue Name ist nicht gültig", "Hinweis");
            }
        }

        private void bnEsc_Click(object sender, EventArgs e) {
            Close();
        }

        private void FRenameWindow_KeyDown(object sender, KeyEventArgs e) {
            if (e.KeyValue == 13) {
                bnOk_Click(sender, e);
            }
            if (e.KeyValue == 27) {
                bnEsc_Click(sender, e);
            }
        }


    }
}
