﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace FM4500 {
    public partial class FCopyMoveDialog : Form {

        public int retCode = -1;

        public FCopyMoveDialog(Form parent, String src, String dst) {
            InitializeComponent();
            this.Owner = parent;  // Important, because CenterOwner            
            this.StartPosition = FormStartPosition.CenterParent; 
            tSrc.Text = src;
            tDest.Text = dst;
        }

        private void FCopyMoveDialog_Load(object sender, EventArgs e) {
            rbCopy.Focus();
        }

        private void bnOk_Click(object sender, EventArgs e) {
            if (this.rbCopy.Checked)
                retCode = 1;
            else
                retCode = 2;
            Close();
        }

        private void bnEsc_Click(object sender, EventArgs e) {
            Close();
        }
    }
}
