﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using System.IO;


namespace FM4500 {
    public partial class FReadFavorit : Form {


        private bool retcode = false;


        public bool Retcode {
            get { return retcode; }
        }


        public String Bez {
            get { return tBez.Text.Trim(); }
        }
        public String Path {
            get { return tPath.Text.Trim(); }
        }

        public FReadFavorit(Form parent, String bez, String path) {
            InitializeComponent();
            this.Owner = parent;  // Important, because CenterOwner       
            this.StartPosition = FormStartPosition.CenterParent;
            tBez.Text = bez;
            tPath.Text = path;
        }

        private void FReadFavoritenProgs_Load(object sender, EventArgs e) {

        }

        private void bnOk_Click(object sender, EventArgs e) {
            if (tBez.Text.Trim().Length == 0) {
                Basis.ErrorMsg("Geben Sie bitte eine Bezeichnung ein", "Hinweis");
                tBez.Focus();
                return;
            }
            if (tPath.Text.Trim().Length == 0) {
                Basis.ErrorMsg("Geben Sie bitte ein Verzeichnis ein", "Hinweis");
                tPath.Focus();
                return;
            }
            if (!Directory.Exists(tPath.Text.Trim())) {
                Basis.ErrorMsg("Das Verzeichnis existiert nicht", "Hinweis");
                tPath.Focus();
                return;
            }
            retcode = true;
            Close();
        }

        private void bnEsc_Click(object sender, EventArgs e) {
            Close();
        }

        private void bnSelectFolder_Click(object sender, EventArgs e) {
            FolderBrowserDialog dialog = new FolderBrowserDialog();
            DialogResult result = dialog.ShowDialog();
            if (result == DialogResult.OK) {
                tPath.Text = dialog.SelectedPath;
            }
        }

        private void FReadFavorit_KeyDown(object sender, KeyEventArgs e) {
            bnOk_Click(sender, null);
        }

        private void FReadFavorit_Load(object sender, EventArgs e) {

        }
    }
}
