﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace FM4500 {
    public partial class FReadString : Form {


        private bool retcode = false;

        public bool Retcode {
            get { return retcode; }
        }

        public String TInput {
            get { return tInput.Text.Trim(); }
        }


        public FReadString(Form parent, String title, String caption, String itemcaption, String tInput) {
            InitializeComponent();
            labelTitel.Text = caption;
            labelItem.Text = itemcaption;
            this.tInput.Text = tInput;
            this.Owner = parent;  // Important, because CenterOwner            
            this.StartPosition = FormStartPosition.CenterParent; 
            this.KeyPreview = true;
        }

        private void FReadString_Load(object sender, EventArgs e) {
            tInput.Focus();
        }

        private void bnOk_Click(object sender, EventArgs e) {
            String newFile = tInput.Text.Trim();
            if (Basis.CheckDateinamen(newFile)) {
                retcode = true;
                Close();
            }
            else {
                Basis.ErrorMsg("Der neue Name ist nicht gültig", "Hinweis");
            }
        }

        private void bnEsc_Click(object sender, EventArgs e) {
            Close();
        }

        private void FReadString_KeyDown(object sender, KeyEventArgs e) {
            if (e.KeyValue == 13) {
                bnOk_Click(sender, e);
            }
            if (e.KeyValue == 27) {
                bnEsc_Click(sender, e);
            }
        }
    }
}
