﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace FM4500 {
    public partial class OwnerDefined : Form {

        private bool retcode = false;

        public bool Retcode {
            get { return retcode; }
        }

        private void OwnerDefined_Load(object sender, EventArgs e) {
            tInput.Focus();
        }


        public String TInput {
            get { return tInput.Text.Trim(); }
        }

        public OwnerDefined(Form parent, String title, String caption, String itemcaption, String tInput) {
            InitializeComponent();
            labelTitel.Text = caption;
            labelItem.Text = itemcaption;
            this.tInput.Text = tInput;
            this.Owner = parent;  // Important, because CenterOwner            
            this.KeyPreview = true;
        }


        private void bnOk_Click(object sender, EventArgs e) {
            if (tInput.Text.Trim().Length > 0) {
                retcode = true;
                Close();
            }
            else {
                Basis.ErrorMsg("Bitte geben Sie eine Maske ein", "Hinweis");
            }
        }

        private void bnEsc_Click(object sender, EventArgs e) {
            Close();
        }


        private void OwnerDefined_KeyDown(object sender, KeyEventArgs e) {
            if (e.KeyValue == 13) {
                bnOk_Click(sender, e);
            }
            if (e.KeyValue == 27) {
                bnEsc_Click(sender, e);
            }
        }

    }
}
